#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
RF24 radio(9, 10); // CE, CSN         
const byte address[6] = "00001";     //Byte of array representing the address. This is the address where we will send the data. This should be same on the receiving side.
//The following are the variables for the different channels on the transmitter
int xVal = 0;
int yVal = 0;
int switchVal = 0;
int potVal = 0;
byte joystick[4];
int xPin = A0;
int yPin = A1;
int switchPin = 7;
int potPin = A4;

//Setup initialises everything we need to start transmitting (serial is not necessary, but helps debugging)
void setup() 
{
  pinMode(xPin, INPUT);
  pinMode(yPin, INPUT);
  pinMode(potPin, INPUT);
  pinMode(switchPin, INPUT_PULLUP);
  Serial.begin(9600);
  radio.begin();                  //Starting the Wireless communication
  radio.openWritingPipe(address); //Setting the address where we will send the data
  radio.setPALevel(RF24_PA_MAX);  //You can set it as minimum or maximum depending on the distance between the transmitter and receiver.
  radio.setDataRate(RF24_250KBPS);  //Need to check this out!!! (also 1MBPS or 2MBPS)
  radio.stopListening();          //This sets the module as transmitter
}

void loop()
{
  xVal = analogRead(xPin);
  yVal = analogRead(yPin);
  switchVal = !(digitalRead(switchPin));  
  potVal = analogRead(potPin);
  if(xVal > 690)
  {
    xVal = 690;
  }
  if(xVal < 325)
  {
    xVal = 325;
  }
  if(yVal > 690)
  {
    yVal = 690;
  }
  if(yVal < 325)
  {
    yVal = 325;
  }
  if(potVal > 1023)
  {
    potVal = 1023;
  }
  if(potVal < 0)
  {
    potVal = 0;
  }
  //First, all individual variables are added to the int array.
  joystick[0] = map(xVal,690,325,0,255);
  joystick[1] = map(yVal,294,735,0,255);
  joystick[2] = switchVal;
  joystick[3] = map(potVal,0,1023,0,255);
  //Serial prints contents of array, just to check it is what we think it is!
  Serial.print(" xVal = ");
  Serial.print(joystick[0]);
  Serial.print(" , y Val =");
  Serial.print(joystick[1]);
  Serial.print(" , switchVal = ");
  Serial.print(joystick[2]);
  Serial.print(" , potVal = ");
  Serial.println(joystick[3]);
  //Array is written to the radio module to send
  radio.write(&joystick, sizeof(joystick));
  delay(20);
}
